Bug 35502 - [Gtk] Objects of ATK_ROLE_TABLE should not implement AtkText
Summary: [Gtk] Objects of ATK_ROLE_TABLE should not implement AtkText
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: Accessibility (show other bugs)
Version: 528+ (Nightly build)
Hardware: PC Linux
: P2 Normal
Assignee: Nobody
URL:
Keywords: Gtk
Depends on:
Blocks: 25531
  Show dependency treegraph
 
Reported: 2010-02-28 14:45 PST by Joanmarie Diggs (irc: joanie)
Modified: 2010-03-15 22:16 PDT (History)
4 users (show)

See Also:


Attachments
proposed fix (2.48 KB, patch)
2010-02-28 16:31 PST, Joanmarie Diggs (irc: joanie)
no flags Details | Formatted Diff | Diff
proposed fix with unit test (5.59 KB, patch)
2010-03-01 12:52 PST, Joanmarie Diggs (irc: joanie)
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Joanmarie Diggs (irc: joanie) 2010-02-28 14:45:32 PST
It turns out that as a side effect of The Great Hierarchy Flattening, tables are now doing a very nice and accurate job of implementing AtkText. :-) The problem with this, however, is potentially two-fold:

* ATs aren't expecting it to be implemented. This might explain some extreme chattiness I'm seeing in Orca when a table gets focus. (It might not. I still need to debug. Regardless....)

* Given a really, really big table, I suspect that this accidental implementation of AtkText might result in a performance hit for users of ATs.

We should probably stop tables from doing this, and let ATs get the text from the cells within the table, just like they do in other Gtk+ apps.
Comment 1 Joanmarie Diggs (irc: joanie) 2010-02-28 16:31:35 PST
Created attachment 49706 [details]
proposed fix

One line fix that seems to solve the problem.

So... How does one write a test to verify that AtkText is *not* implemented? In other words, doesn't testing that tables do not implement AtkText cause the test to fail because AtkText is no longer implemented for tables? :-/

Ideas welcome if this fix must have a test in order to be accepted. Thanks!
Comment 2 Joanmarie Diggs (irc: joanie) 2010-03-01 12:52:14 PST
Created attachment 49740 [details]
proposed fix with unit test

I was chatting with Xan about this. He provided a way to test that we are no longer implementing AtkText for tables. (Thanks!)

If such a test is worth doing, then I propose this patch; if it's not, I propose the first one. :-) For now, obsoleting the original.
Comment 3 Holger Freyther 2010-03-07 23:54:53 PST
Comment on attachment 49740 [details]
proposed fix with unit test

okay.
Comment 4 Joanmarie Diggs (irc: joanie) 2010-03-08 09:58:22 PST
Comment on attachment 49740 [details]
proposed fix with unit test

(In reply to comment #3)
> (From update of attachment 49740 [details])
> okay.

Thanks! I assume I need to set the commit-queue? flag?
Comment 5 WebKit Commit Bot 2010-03-15 22:16:06 PDT
Comment on attachment 49740 [details]
proposed fix with unit test

Clearing flags on attachment: 49740

Committed r56036: <http://trac.webkit.org/changeset/56036>
Comment 6 WebKit Commit Bot 2010-03-15 22:16:12 PDT
All reviewed patches have been landed.  Closing bug.